import DataUtils from '../utils/DataUtils';
import VerifyUtils from "../utils/VerifyUtils";
import GeoJsonProvider from '../geog/GeoJsonProvider';
import AnnotationLayer from '../common/AnnotationLayer';
import SimpleMarkerLayer from '../common/SimpleMarkerLayer';
import LayerProvider from '../geog/LayerProvider';

/**
 * 定义工地图层
 *
 * @alias BuildingsiteLayer
 *
 * @summary <用于加载工地点位图层>
 */
export default class BuildingsiteLayer {
  /**
   * 构造函数
   * @param {Object} options -图层选项
   */
  constructor(options) {
    /**
     * 地图对象
     * @type {Object}
     */
    this._map = options.map;

    /**
     * 最小缩放层级
     * @type {Number}
     */
    this._minzoom = DataUtils.default(options.minzoom, 10);

    /**
     * 图标ID
     * @type {String}
     */
    this._icon = DataUtils.default(options.icon, 'busi_site');

    /**
     * 数据源ID
     * @type {String}
     */
    this._sourceId = DataUtils.default(options.sourceId, 'pipe_facility_site');

    /**
     * 图层ID
     * @type {String}
     */
    this._layerId = DataUtils.default(options.layerId, this._sourceId);
    this._lableLayerId = this.layerId + '-label';

    // 图层
    this._markerLayer = null;
    this._lableLayer = null;
    // 初始化图层
    this._initLayers();
  }

  /** 公有方法 **/
  /**
   * 设置数据
   * @param {Object|Array} data -GeoJson要素/要素集/点位数组
   */
  setData(data = null) {
    let fc = null;
    if (VerifyUtils.isGeoJsonFC(data)) {
      fc = data;
    } else if (VerifyUtils.isGeoJsonFeature(data)) {
      fc = GeoJsonProvider.getEmptyFC();
      fc.features = [data];
    } else if (VerifyUtils.isArray(data)) {
      fc = GeoJsonProvider.data2PointFC(data);
    }

    this._fc = fc || GeoJsonProvider.getEmptyFC();
    // 设置数据
    this._markerLayer.setData(this._fc);
    this._lableLayer.setData(this._fc);
  }

  /**
   * 设置过滤器
   * @param {Array} filter -过滤器
   */
  setFilter(filter) {
    this._markerLayer.setFilter(filter);
    this._lableLayer.setFilter(filter);
  }

  /**
   * 加载图层
   */
  loadLayer() {
    // 加载图层
    if (!this.hasLayer()) {
      this._markerLayer.loadLayer();
    }

    this.showLayer(true);
  }

  /**
   * 显示/隐藏图层
   * @param {Boolean} isShow -是否显示
   */
  showLayer(isShow) {
    this._markerLayer.showLayer(isShow);
    this._lableLayer.showLayer(isShow);
  }

  /**
   * 判断图层是否已加载
   *
   * @returns {Boolean}
   */
  hasLayer() {
    return (
      this._markerLayer.hasLayer() &&
      this._lableLayer.hasLayer()
    );
  }

  /**
   * 移除图层
   */
  removeLayer() {
    this._lableLayer.removeLayer();
    this._markerLayer.removeLayer();

    // 移除数据源
    this._markerLayer.removeSource();
  }

  /**
   * 绑定单击事件
   * @param {Function} event -事件函数
   */
  onClick(event) {
    this._markerLayer.onClick(event);
  }

  /**
   * 绑定事件
   * @param {String} name -事件名称
   * @param {Function} event -事件函数
   */
  onEvent(name, event) {
    this._markerLayer.onEvent(name, event);
  }

  /** 私有方法 **/
  /**
   * 初始化图层
   */
  _initLayers() {
    const map = this._map;
    const minZoom = this._minzoom;

    // 点图层
    this._markerLayer = new SimpleMarkerLayer({
      map: map,
      minzoom: minZoom,
      icon: this._icon,
      sourceId: this._sourceId,
      layerId: this._layerId
    });

    // 标注图层
    this._lableLayer = new AnnotationLayer({
      map: map,
      minzoom: minZoom + 2.75,
      field: 'name',
      textSize: 13,
      textOffset: [0, -1.75],
      sourceId: this._sourceId,
      layerId: this._lableLayerId
    });
  }
}
